## org.jfree.data.time
Class Hour

    java.lang.Object
      org.jfree.data.time.RegularTimePeriod
          org.jfree.data.time.Hour

All Implemented Interfaces:
  java.io.Serializable, java.lang.Comparable, TimePeriod, org.jfree.date.MonthConstants

    public class Hour

extends RegularTimePeriod
implements java.io.Serializable

Represents an hour in a specific day. This class is immutable, which is a requirement for all `RegularTimePeriod` subclasses.

See Also:
  Serialized Form

Field Summary
`static int` `FIRST_HOUR_IN_DAY` Useful constant for the first hour in the day.
`static int` `LAST_HOUR_IN_DAY` Useful constant for the last hour in the day.

Fields inherited from class org.jfree.data.time.RegularTimePeriod
`DEFAULT_TIME_ZONE, WORKING_CALENDAR`

Fields inherited from interface org.jfree.date.MonthConstants
`APRIL, AUGUST, DECEMBER, FEBRUARY, JANUARY, JULY, JUNE, MARCH, MAY, NOVEMBER, OCTOBER, SEPTEMBER`

Constructor Summary
`Hour()` Constructs a new Hour, based on the system date/time.
`Hour(java.util.Date time)` Constructs a new Hour, based on the supplied date/time.
`Hour(java.util.Date time, java.util.TimeZone zone)` Constructs a new Hour, based on the supplied date/time evaluated in the specified time zone.
`Hour(int hour, Day day)` Constructs a new Hour.
`Hour(int hour, int day, int month, int year)` Creates a new hour.

Method Summary
`int` `compareTo(java.lang.Object o1)` Returns an integer indicating the order of this Hour object relative to the specified object: negative == before, zero == same, positive == after.
`boolean` `equals(java.lang.Object obj)` Tests the equality of this object against an arbitrary Object.
`Day` `getDay()` Returns the day in which this hour falls.
`int` `getDayOfMonth()` Returns the day-of-the-month in which this hour falls.
`long` `getFirstMillisecond()` Returns the first millisecond of the hour.
`long` `getFirstMillisecond(java.util.Calendar calendar)` Returns the first millisecond of the hour.
`int` `getHour()` Returns the hour.
`long` `getLastMillisecond()` Returns the last millisecond of the hour.
`long` `getLastMillisecond(java.util.Calendar calendar)` Returns the last millisecond of the hour.
`int` `getMonth()` Returns the month in which this hour falls.
`long` `getSerialIndex()` Returns a serial index number for the hour.
`int` `getYear()` Returns the year in which this hour falls.
`int` `hashCode()` Returns a hash code for this object instance.
`RegularTimePeriod` `next()` Returns the hour following this one.
`static Hour` `parseHour(java.lang.String s)` Creates an Hour instance by parsing a string.
`void` `peg(java.util.Calendar calendar)` Recalculates the start date/time and end date/time for this time period relative to the supplied calendar (which incorporates a time zone).
`RegularTimePeriod` `previous()` Returns the hour preceding this one.

Methods inherited from class org.jfree.data.time.RegularTimePeriod
`createInstance, downsize, getEnd, getFirstMillisecond, getLastMillisecond, getMiddleMillisecond, getMiddleMillisecond, getMiddleMillisecond, getStart, toString`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### FIRST_HOUR_IN_DAY

    public static final int FIRST_HOUR_IN_DAY

  Useful constant for the first hour in the day.

  See Also:
    Constant Field Values

### LAST_HOUR_IN_DAY

    public static final int LAST_HOUR_IN_DAY

  Useful constant for the last hour in the day.

  See Also:
    Constant Field Values

Constructor Detail

### Hour

    public Hour()

  Constructs a new Hour, based on the system date/time.

### Hour

    public Hour(int hour,
                Day day)

  Constructs a new Hour.

  Parameters:
    `hour` - the hour (in the range 0 to 23).
    `day` - the day (`null` not permitted).

### Hour

    public Hour(int hour,
                int day,
                int month,
                int year)

  Creates a new hour.

  Parameters:
    `hour` - the hour (0-23).
    `day` - the day (1-31).
    `month` - the month (1-12).
    `year` - the year (1900-9999).

### Hour

    public Hour(java.util.Date time)

  Constructs a new Hour, based on the supplied date/time.

  Parameters:
    `time` - the date-time (`null` not permitted).

### Hour

    public Hour(java.util.Date time,
                java.util.TimeZone zone)

  Constructs a new Hour, based on the supplied date/time evaluated in the specified time zone.

  Parameters:
    `time` - the date-time (`null` not permitted).
    `zone` - the time zone (`null` not permitted).

Method Detail

### getHour

    public int getHour()

  Returns the hour.

  Returns:
    The hour (0 <= hour <= 23).

### getDay

    public Day getDay()

  Returns the day in which this hour falls.

  Returns:
    The day.

### getYear

    public int getYear()

  Returns the year in which this hour falls.

  Returns:
    The year.

### getMonth

    public int getMonth()

  Returns the month in which this hour falls.

  Returns:
    The month.

### getDayOfMonth

    public int getDayOfMonth()

  Returns the day-of-the-month in which this hour falls.

  Returns:
    The day-of-the-month.

### getFirstMillisecond

    public long getFirstMillisecond()

  Returns the first millisecond of the hour. This will be determined relative to the time zone specified in the constructor, or in the calendar instance passed in the most recent call to the `peg(Calendar)` method.

  Specified by:
    `getFirstMillisecond` in class `RegularTimePeriod`
  Returns:
    The first millisecond of the hour.
  See Also:
    `getLastMillisecond()`

### getLastMillisecond

    public long getLastMillisecond()

  Returns the last millisecond of the hour. This will be determined relative to the time zone specified in the constructor, or in the calendar instance passed in the most recent call to the `peg(Calendar)` method.

  Specified by:
    `getLastMillisecond` in class `RegularTimePeriod`
  Returns:
    The last millisecond of the hour.
  See Also:
    `getFirstMillisecond()`

### peg

    public void peg(java.util.Calendar calendar)

  Recalculates the start date/time and end date/time for this time period relative to the supplied calendar (which incorporates a time zone).

  Specified by:
    `peg` in class `RegularTimePeriod`
  Parameters:
    `calendar` - the calendar (`null` not permitted).
  Since:
    1.0.3

### previous

    public RegularTimePeriod previous()

  Returns the hour preceding this one.

  Specified by:
    `previous` in class `RegularTimePeriod`
  Returns:
    The hour preceding this one.

### next

    public RegularTimePeriod next()

  Returns the hour following this one.

  Specified by:
    `next` in class `RegularTimePeriod`
  Returns:
    The hour following this one.

### getSerialIndex

    public long getSerialIndex()

  Returns a serial index number for the hour.

  Specified by:
    `getSerialIndex` in class `RegularTimePeriod`
  Returns:
    The serial index number.

### getFirstMillisecond

    public long getFirstMillisecond(java.util.Calendar calendar)

  Returns the first millisecond of the hour.

  Specified by:
    `getFirstMillisecond` in class `RegularTimePeriod`
  Parameters:
    `calendar` - the calendar/timezone (`null` not permitted).
  Returns:
    The first millisecond.
  Throws:
    `java.lang.NullPointerException` - if `calendar` is `null`.
  See Also:
    `RegularTimePeriod.getLastMillisecond(Calendar)`

### getLastMillisecond

    public long getLastMillisecond(java.util.Calendar calendar)

  Returns the last millisecond of the hour.

  Specified by:
    `getLastMillisecond` in class `RegularTimePeriod`
  Parameters:
    `calendar` - the calendar/timezone (`null` not permitted).
  Returns:
    The last millisecond.
  Throws:
    `java.lang.NullPointerException` - if `calendar` is `null`.
  See Also:
    `RegularTimePeriod.getFirstMillisecond(Calendar)`

### equals

    public boolean equals(java.lang.Object obj)

  Tests the equality of this object against an arbitrary Object.

  This method will return true ONLY if the object is an Hour object representing the same hour as this instance.

  Overrides:
    `equals` in class `java.lang.Object`
  Parameters:
    `obj` - the object to compare (`null` permitted).
  Returns:
    `true` if the hour and day value of the object is the same as this.

### hashCode

    public int hashCode()

  Returns a hash code for this object instance. The approach described by Joshua Bloch in "Effective Java" has been used here:

  `http://developer.java.sun.com/developer/Books/effectivejava /Chapter3.pdf`

  Overrides:
    `hashCode` in class `java.lang.Object`
  Returns:
    A hash code.

### compareTo

    public int compareTo(java.lang.Object o1)

  Returns an integer indicating the order of this Hour object relative to the specified object: negative == before, zero == same, positive == after.

  Specified by:
    `compareTo` in interface `java.lang.Comparable`
  Parameters:
    `o1` - the object to compare.
  Returns:
    negative == before, zero == same, positive == after.

### parseHour

    public static Hour parseHour(java.lang.String s)

  Creates an Hour instance by parsing a string. The string is assumed to be in the format "YYYY-MM-DD HH", perhaps with leading or trailing whitespace.

  Parameters:
    `s` - the hour string to parse.
  Returns:
    `null` if the string is not parseable, the hour otherwise.